/****************************************************************************************
    Copyright 2004 uja 
    Copyright 2004 Trolltech (Qt3)
    published under GPL
    This file is part of Zehner: game implementation
*****************************************************************************************/
#include <stdio.h> // for debugging purpose
#include "chips.h"
#include <math.h>

// 24.09.2004 uja: neuner geklont, config.h angepasse
// 25.09.2004 uja: spielbare Version: spielstart, abraeumen, talon_drehen, talon2stack, talon2reihe  (zehner-spezifische Teile) 
// ------------------------------------------------------------------------------------------------------------------------------


// Listenroutinen-Auszug: (c)uja 1989
int  in_liste(int e,int l[])  { int i,k=-1; if (l[0]>0) for (i=1; i<=l[0]; i++) if (e==l[i]) k=i; return k; }
void add_liste(int e,int l[]) { if (in_liste(e,l)<1) { l[0]++; l[l[0]]=e; } }

// ======================================================================================================================

karte::karte(int fa,int bi,int de,bool o) 
{ 
  farbe=fa; bild=bi; deck=de; 
  x=0; y=0;
  z=bild+13*farbe+NUMSPRITES*deck; 
  code=bild+13*farbe; 
  dpix=2*NUMSPRITES+deck;
  offen=o;
}

void karte::open_card(bool o) { offen=o; norm_card(); }
void karte::move_card(int xx,int yy,int zz) { x=xx; y=yy, z=zz; p_sprite->setZ(z); p_sprite->move(x,y); }
void karte::mark_card() { p_sprite->setFrame(code+NUMSPRITES); } 
void karte::norm_card() { if (offen) p_sprite->setFrame(code); else p_sprite->setFrame(dpix); }

bool karte::is_open()   { return offen; }
int  karte::get_farbe() { return farbe; }
int  karte::get_bild()  { return bild;  }

// ========================================================================================================================

chips::chips(QWidget* parent)
{ 
  int i,j,k,ii=0;
  for (k=0; k<NUMBG; k++) for (j=0; j<4; j++) for (i=0; i<13; i++)   
  {   
    talon[ii]=ii;
    my_card[ii]=new karte(j,i,k,true);
    ii++; 
  }
  akt_zug.feld=-1;
  ani1=true;
  ani2=true;
  stopper=new QTimer(this); 
  tic=100; // Animationstimer
  srand(time(0)); 
  connect(stopper,SIGNAL(timeout()),this,SLOT(cycle()));                     // Endebild
  connect(this,SIGNAL(send_messi(QString)),parent,SLOT(set_messi(QString))); // Restanzeige
}

// ---------------------------------------------------------------------------------

// Check, ob Karten zueinander passen:
bool chips::passt(karte* k1,karte* k2,bool farbwechsel,bool aufsteigend, bool wrap)
{
  int diff;
  bool ok;
  if (farbwechsel) ok=(k1->get_farbe()/2 != k2->get_farbe()/2); else ok=(k1->get_farbe()==k2->get_farbe());
  if (ok) 
  { diff=k1->get_bild()-k2->get_bild(); if (aufsteigend) ok=(diff==1); else ok=(diff==-1);
    if (!ok) if (wrap)
    { if (aufsteigend) ok=((k1->get_bild()==0) && (k2->get_bild()==12));
       else ok=((k1->get_bild()==12) && (k2->get_bild()==0));
    }       
  }    
  return ok;    
}

// suchen nach oberster freier Karte in Kartenreihe, Rueckgabe: Position in Reihe
int chips::oberste_freie(int nr)
{
  int i,j,frei=r_liste[nr][0];
  bool weiter=true;
  while ((frei>1) && (weiter))  
  { 
    i=r_liste[nr][frei];
    j=r_liste[nr][frei-1];
    if (my_card[j]->is_open()) { if (passt(my_card[i],my_card[j],false,false,true)) frei--; else weiter=false; } else weiter=false;
  }
  return frei;
}


// Feststellen und markieren der zu verschiebenden Karten im Reihenbereich: Reihennr,Startkarte

int chips::markiere_reihe(int nr,int start)
{
  int i,k,erste=oberste_freie(nr);
  if (erste<start) erste=start;  
  for (i=erste; i<=r_liste[nr][0]; i++) { k=r_liste[nr][i]; my_card[k]->mark_card(); }
  return erste;
}


// Zeichnen einer Spalte samt Cleanup (letzte oeffnen), kann Anzeige bereinigen:
void chips::zeige_reihe(int nr)
{
  int i,k,x;
  if (r_liste[nr][0]>0) for (i=1; i<=r_liste[nr][0]; i++)
  { 
    k=r_liste[nr][i];
    x=OFX+nr*DX;
    my_card[k]->move_card(x,OFY+(i-1)*DDY,i);
    my_card[k]->norm_card();
  }
  k=r_liste[nr][r_liste[nr][0]];
  my_card[k]->open_card(true);
}


void chips::loesche_marken()
{ 
  switch (akt_zug.feld)
  {
    case 0: my_card[talon_offen[talon_offen[0]]]->norm_card(); break;
    case 1: my_card[s_liste[akt_zug.posnr][akt_zug.posi]]->norm_card(); break;
    case 2: for (int i=1; i<=r_liste[akt_zug.posnr][0]; i++) my_card[r_liste[akt_zug.posnr][i]]->norm_card(); break;
  }  
  akt_zug.feld=-1;

}

void chips::updat_rest()
{
  QString mess;
  int i=talon_offen[0]+talon_zu[0];
  mess.setNum(i);
  mess="Rest: "+mess;
  emit send_messi(mess);
}


void chips::letzte_oeffnen(int nr) { if (r_liste[nr][0]>0) my_card[r_liste[nr][r_liste[nr][0]]]->open_card(true); }

// ----------------------------------------------------------------------------------------------------------------
// moegliche Zuege:
// ---------------------------------------------------------------------------------------------------------------

// one-klick

void chips::talon_drehen()
{
  loesche_marken();
  if ((talon_zu[0]==0) && (talon_offen[0]>0))
  { int i,ix,iy;
    for (i=talon_offen[0]; i>0; i--) add_liste(talon_offen[i],talon_zu); 
    talon_offen[0]=0;
    for (i=1; i<=talon_zu[0]; i++) 
    { ix=OFXA+SMAX*DX+rand()%4+24;
      iy=OFYA+rand()%4;
      my_card[talon_zu[i]]->open_card(false); 
      my_card[talon_zu[i]]->move_card(ix,iy,i);
    }
  }
}

void chips::karte_drehen()
{
  loesche_marken();
  if (talon_zu[0]>0)
  { add_liste(talon_zu[talon_zu[0]],talon_offen); 
    talon_zu[0]--;
    int nr=talon_offen[0],ix=OFXA+(SMAX+1)*DX+rand()%4+24,iy=OFYA+rand()%4;    
    my_card[talon_offen[nr]]->open_card(true); 
    my_card[talon_offen[nr]]->move_card(ix,iy,nr);
  }
  else if (talon_offen[0]>0) talon_drehen();
}


// two-klick:

bool chips::talon2stack(int nr) 
{ 
  bool moveit=false;
  loesche_marken();
  if (talon_offen[0]>0)
  { int n1=talon_offen[talon_offen[0]],n2=s_liste[nr][s_liste[nr][0]];
    moveit=((s_liste[nr][0]<1) && (my_card[n1]->get_bild()==0) && (my_card[n1]->get_farbe()==nr%4)); 
    if (!moveit) moveit=((s_liste[nr][0]>0) && (passt(my_card[n1],my_card[n2],false,true,false)));
    if (moveit) 
    { 
      add_liste(n1,s_liste[nr]); 
      talon_offen[0]--;
      my_card[n1]->move_card(OFXA+nr*DX,OFYA,s_liste[nr][0]);
    } 
  }    
  return moveit;   
}    

bool chips::talon2reihe(int nr) 
{ 
  loesche_marken();
  int n1=talon_offen[talon_offen[0]],n2=r_liste[nr][r_liste[nr][0]];
  bool moveit=((talon_offen[0]>0) && (passt(my_card[n1],my_card[n2],false,false,true)));
  if (!moveit) moveit=((r_liste[nr][0]<1) && (my_card[n1]->get_bild()==12)); 
  if (moveit) 
  { 
    add_liste(n1,r_liste[nr]);
    talon_offen[0]--;
    my_card[n1]->move_card(OFX+nr*DX,OFY+DDY*(r_liste[nr][0]-1),r_liste[nr][0]);
  } 
  return moveit;   
}    

bool chips::stack2stack(int n1,int n2)
{
  loesche_marken();
  bool moveit=false;
  int i=s_liste[n1][0],j=s_liste[n2][0];
  if (i>0) 
  { i=s_liste[n1][i];
    if (j<1) { if (my_card[i]->get_farbe()==n2%4) if (my_card[i]->get_bild()==0) moveit=true; }
    else     { j=s_liste[n2][j]; moveit=passt(my_card[i],my_card[j],false,true,false); }     
  }
  if (moveit)
  {
    s_liste[n1][0]--; add_liste(i,s_liste[n2]);
    my_card[i]->move_card(OFXA+n2*DX,OFYA,s_liste[n2][0]);
  }
  return moveit;
}

bool chips::stack2reihe(int n1,int n2)
{
  loesche_marken();
  bool moveit=false;
  int i=s_liste[n1][0],j=r_liste[n2][0];
  if (i>0) 
  { i=s_liste[n1][i];
    if ((j<1) && (my_card[i]->get_bild()==12)) moveit=true; 
    else moveit=passt(my_card[i],my_card[r_liste[n2][j]],false,false,true);
  }  
  if (moveit)
  {
    s_liste[n1][0]--; add_liste(i,r_liste[n2]);
    my_card[i]->move_card(OFX+n2*DX,OFY+(r_liste[n2][0]-1)*DDY,r_liste[n2][0]);
  }
  return moveit;
}


bool chips::reihe2stack(int n1,int n2)
{
  loesche_marken();
  bool moveit=false;
  int i=r_liste[n1][0],j=s_liste[n2][0];
  if (i>0) 
  { i=r_liste[n1][i];
    if (j<1) { if (my_card[i]->get_farbe()==n2%4) if (my_card[i]->get_bild()==0) moveit=true; }
    else     { j=s_liste[n2][j]; moveit=passt(my_card[i],my_card[j],false,true,false); }     
  }
  if (moveit)
  {
    r_liste[n1][0]--; add_liste(i,s_liste[n2]);
    my_card[i]->move_card(OFXA+n2*DX,OFYA,s_liste[n2][0]);
    letzte_oeffnen(n1);
  }
  return moveit;
}


bool chips::reihe2reihe(int n1,int n2)
{
  loesche_marken();
  bool moveit=false;
  int i=r_liste[n1][akt_zug.posi],j=r_liste[n2][0];
  if ((j<1) && (my_card[i]->get_bild()==12)) moveit=true; else moveit=passt(my_card[i],my_card[r_liste[n2][j]],false,false,true);  
  if (n1==n2) moveit=false;
  if (moveit)
  {
    for (i=akt_zug.posi; i<=r_liste[n1][0]; i++) add_liste(r_liste[n1][i],r_liste[n2]);    
    r_liste[n1][0]=akt_zug.posi-1; // Achtng bei n1=n2! Abfangen!
    letzte_oeffnen(n1);
    zeige_reihe(n2);
  }
  return moveit;
}

// -----------------------------------------------------------------------------------------------------------------------
// Slots:
// -----------------------------------------------------------------------------------------------------------------------

// mischen, weiterreichen nach spielstart:
void chips::neues_spiel()
{ 
  int i,j,k;
  for (i=0; i<2*NUMSPRITES; i++) talon[i]=i; 
  for (i=0; i<2*NUMSPRITES; i++) { k=rand()%(2*NUMSPRITES); j=talon[i]; talon[i]=talon[k]; talon[k]=j; } 
  spielstart();
}

void chips::spielstart()
{
  stopper->stop();
  int i,j,k;
  for (i=0; i<SMAX; i++) s_liste[i][0]=0;
  for (i=0; i<RMAX; i++) r_liste[i][0]=0;
  talon_offen[0]=0;
  talon_zu[0]=0;
  k=2*NUMSPRITES;
  for (i=0; i<k; i++) my_card[i]->open_card(false);
  for (j=0; j<RMAX; j++) for (i=j; i<RMAX; i++) { k--; add_liste(talon[k],r_liste[j]); }    
  for (i=0; i<k; i++) add_liste(talon[i],talon_offen);
  for (i=0; i<RMAX; i++) zeige_reihe(i);
  talon_drehen();
  karte_drehen();
  loesche_marken();
  updat_rest();
  aktiv=true;
}

void chips::autoplay()  // heisst abraeumen in anderen Versionen
{
  loesche_marken();
  int i;
  bool geraeumt=false;
  if (talon_offen[0]>0) for (i=0; i<SMAX; i++) if (talon2stack(i)) geraeumt=true;
  for (i=0; i<RMAX; i++) for (int j=0; j<SMAX; j++) if (reihe2stack(i,j)) geraeumt=true; 
  updat_rest();
  if (geraeumt) QTimer::singleShot(tic,this,SLOT(autoplay())); 
  else if (is_ende()) QTimer::singleShot(500,this,SLOT(enderoutine()));  
}

void chips::klick(int xx,int yy)
{ 
  int ix;
  if (aktiv) 
  { 
    if ((yy<OFY) && (xx>SMAX*DX)) // Klick auf einen der Talons: *immer* neuer Start
    { loesche_marken();
      if (xx<(SMAX+1)*DX+24+OFXA) karte_drehen(); 
      else if (talon_offen[0]>0) { akt_zug.feld=0; akt_zug.posi=talon_offen[0]; my_card[talon_offen[akt_zug.posi]]->mark_card(); }
    } 
    else if (akt_zug.feld<0) // Startkarte waehlen aus Stack oder Reihenfeld 
    {   
      if (yy<OFY) 
      { akt_zug.feld=1; 
        akt_zug.posnr=(xx-OFXA)/DX; 
	akt_zug.posi=s_liste[akt_zug.posnr][0];
	if (akt_zug.posi>0) my_card[s_liste[akt_zug.posnr][akt_zug.posi]]->mark_card(); else akt_zug.feld=-1; 
      } 
      else 
      { akt_zug.feld=2; 
        akt_zug.posnr=(xx-OFX)/DX; 
        akt_zug.posi=(yy-OFY)/DDY+1; 
	if (akt_zug.posi>r_liste[akt_zug.posnr][0]) akt_zug.posi=r_liste[akt_zug.posnr][0];
	if (akt_zug.posi>0) akt_zug.posi=markiere_reihe(akt_zug.posnr,akt_zug.posi); else akt_zug.feld=-1; 
      }
    }  
    else // Ziel-Karte waehlen:  
    {    
      if ((yy<OFY) && (xx<SMAX*DX+OFXA)) // Karten zum stack
      { 
        ix=(xx-OFXA)/DX; if (ix<0) ix=0; if (ix>=SMAX) ix=SMAX-1;
        switch (akt_zug.feld)
	{ 
	  case 0: talon2stack(ix); break;
	  case 1: stack2stack(akt_zug.posnr,ix); break;
	  case 2: reihe2stack(akt_zug.posnr,ix); break;
	}  
        if (is_ende()) QTimer::singleShot(500,this,SLOT(enderoutine()));
      }	
      else if (xx<RMAX*DX+OFX) 
      { 
        ix=(xx-OFX)/DX;  if (ix<0) ix=0; if (ix>=RMAX) ix=RMAX-1;
        switch (akt_zug.feld)
	{ 
	  case 0: talon2reihe(ix); break;
	  case 1: stack2reihe(akt_zug.posnr,ix); break;
	  case 2: reihe2reihe(akt_zug.posnr,ix); break;
	}  
      }
      else loesche_marken();
      updat_rest();
    }              
  } 
  else stopper->stop();
}


// --- Ende-Schnickschnack: -------------------------------------------------------------------------------

bool chips::is_ende()        { int i,k=0; for (i=0; i<SMAX; i++) k=k+s_liste[i][0]; return (k>=2*NUMSPRITES); }

void chips::enderoutine() 
{ 
  aktiv=false; 
  int i,mx=256,my=256,iradx=240,irady=96,ix,iy;
  float alpha=0.483312,xx,yy;
  
  for (i=0; i<NUMSPRITES; i++) 
  { xx=iradx*cos(alpha*i);
    yy=irady*sin(alpha*i);
    ix=round(xx+mx);
    iy=round(yy+my);
    my_card[i]->open_card(true);
    my_card[i]->p_sprite->move(ix,iy);
    my_card[i]->p_sprite->setZ(104-i);
    iradx=iradx-3;
    irady=irady-2;    
  }
  stopper->start(50);
}

void chips::cycle()
{
  int i,k; 
  for (i=0; i<NUMSPRITES; i++) { k=(my_card[i]->p_sprite->frame()+1)%NUMSPRITES; my_card[i]->p_sprite->setFrame(k); }
}

// ==================================================================================================================================
